#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <assert.h>
#include "find.h"
#include "enums.h"
  
int repcount;
int sense;

/*
 * 
 * Comments: dante July 14, 1991
 *
 * Oh yeah, one more thing.  Don't mess with this code, not any of
 * you AR-meisters!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 */

static int MAXBUFF = 8192;
extern int dflag;
char *printbuffer;

/*
 *
 * Tracked-malloc routine.
 *
 */

int blockCount =0;

typedef struct block {
  char far *address;
  struct block far *next;
} Block;

Block far *thead = NULL;
Block far *ttail = NULL;

char far *tmalloc(size)
     unsigned long size;
{
  /* Create a block and allocate the memory. */
  Block far *block = (Block far  *) farmalloc(sizeof(struct block));
  block->address = (char far *) farmalloc(size);
  block->next = NULL;
  ++blockCount;

  /* Link the block into the list. */
  if (thead == NULL) {
    thead = block;
    ttail = block;
  }
  else {
    ttail->next = block;
    ttail = block;
  }

  return block->address;
}

void freeAll()
{
  Block *block = thead;
  Block *next;

  /* Walk the list of blocks and free all memories. */
  while (block != NULL) {
    next = block->next;
    farfree(block->address);
    farfree(block);
    
    --blockCount;
    block = next;
  }
  thead = NULL;
  ttail = NULL;
}


/* downcase a word */
char *strtolower(word)
     char *word;
{
  char *y;
  y=word;
  while(*y){
    if(isupper(*y))
      *y=tolower(*y);
    if(*y == '(')
      *y='\0';
    y++;
  }
  return(word);
}

/* strsubst - replace all occurences of ch1 with ch2 in string */

char *strsubst(str, from, to)
     char *str;
     char from;
     char to;
{
  char *p;
  for (p = str; *p != 0; ++p)
    if (*p == from)
      *p = to;
  return str;
}

/* strip off () enclosed comments from a word */
char *deadjify(word)
     char *word;
{
  char *y;
  y=word;
  while(*y){
    if(*y == '(')
      *y='\0';
    y++;
  }
  return(word);
}

/*
 * given a word and a part of speech marker ADJSS,NOUNSS,VERBSS
 * returns an index entry struct ndex.
 */
ndex *lookup_binx(word,dbase)
     char *word;
     int  dbase;
{
  char *foo;
  char *getenv();
  char searchdir[512];
  char indexname[512];
  int c;
  long top,mid,bot,diff;
  FILE *fp, *fopen();
  char *beglp,*endlp,*term,key[120],linea[4096],lineb[4096];
  char dead[20];
  char tnum[10];
  char *ptrtok;
  long line1,line2;
  int length,oops,i;

  ndex *retval;

  retval = (ndex *) farmalloc(sizeof(ndex));

  retval->true=0;
  retval->wd='\0';
  retval->pos='\0';
  retval->num=0;
  retval->col=0;
  retval->off='\0';
  retval->cnt=0;
  retval->use='\0';
  
  diff=666;

  strcpy(searchdir,((foo=getenv("WNSEARCHDIR")) ? foo
		    : "."));
  sprintf(indexname,"%s\\%s.mas",searchdir,partnames[dbase]);
  if((fp=fopen(indexname,"r")) == NULL) {
    fprintf(stderr, "Error: can't open indexfile(%s)\n",indexname);
    exit(666);
  }
  
  fseek(fp,0L,2);
  top=0;
  bot=ftell(fp);
  mid=(bot-top)/2;

  sprintf(key,"");
  term=word;
  
  term=strchr(term,'\0');
  while((strcmp(word,key)) && (diff != 0))
    {
      fseek(fp,mid-1,0);
      
      if(mid != 1)
	while((c=getc(fp))!='\n'  && c != EOF);
      
      fgets(linea, 4096, fp);
      beglp=linea;
      endlp=beglp;
      endlp=strchr(endlp,' ');
      
      strncpy(key,beglp,endlp-beglp);
      length=endlp-beglp;
      endlp=key;
      endlp += length;
      *endlp='\0';
      if(strcmp(key,word) < 0)
	{
	  top=mid;
	  bot=bot;
	  diff=(bot-top)/2;
	  mid=top+diff;
	}
      if(strcmp(key,word) > 0)
	{
	  bot=mid;
	  top=top;
	  diff=(bot-top)/2;
	  mid=top+diff;
	}
    }
  fclose(fp);
  
  if(!strcmp(word,key))
    {
      retval->true=1;
      
      /* get the word */
      ptrtok=strtok(linea," \n");
      
      retval->wd=(char *) farmalloc(strlen(ptrtok) + 1);

      sprintf(retval->wd,"%s",linea);
      
      /* get the part of speech */
      ptrtok=strtok(NULL," \n");
      retval->pos=(char *) farmalloc(strlen(ptrtok) + 1);

      sprintf(retval->pos,"%s",ptrtok);
      
      /* get the collins count */
      ptrtok=strtok(NULL," \n");
      retval->col = atoi(ptrtok);
      
      /* get the number of pointers types */
      ptrtok=strtok(NULL," \n");
      retval->cnt = atoi(ptrtok);
      
      retval->use = (int *) farmalloc(retval->cnt * (sizeof(int)));

      /* get the pointers types */
      for(oops=0;oops < retval->cnt; oops++)
	{
	  ptrtok=strtok(NULL," \n");
	  
	  for(i=0;i<MAXPTR;i++)
	    {
	      if(!strcmp(ptrtok,ptrtyp[i]))
		retval->use[oops]=i;
	    }
	}
      
      /* get the number of offsets */
      ptrtok=strtok(NULL," \n");
      retval->num = atoi(ptrtok);
      
      /* make space for the offsets */
      retval->off = (long *) farmalloc(retval->num * (sizeof(long)));

      /* get the offsets */
      for(oops=0;oops<retval->num;oops++)
	{
	  ptrtok=strtok(NULL," \n");
	  strcpy(tnum,ptrtok);
	  retval->off[oops] = strtol(tnum,NULL,10);
	}
    }
  return(retval);
}

int is_defined(word,dbase)
     char *word;
     int  dbase;
     
{
  ndexptr index;
  int i;
  int retval=0;

  index=lookup_binx(word,dbase);
  
  if(index->true)
    {
      switch(dbase)
	{
	case ADJSS:  retval = retval | bit(SIMPTR) | bit(FREQ) | bit(ANTPTR);
	  break;
	case NOUNSS: retval = retval | bit(SIMPTR) | bit(FREQ);
	  if(traceword(word))
	    retval = retval | bit(32);
	  break;
	case VERBSS: retval = retval | bit(SIMPTR) | bit(FREQ) | bit(FRAMES);
	  break;
	}
      
      for(i=0;i<index->cnt;i++)
	{
	  if(index->use[i]>=6 && index->use[i]<=8)
	    retval=retval | bit(13);
	  if(index->use[i]>=9 && index->use[i]<=11)
	    retval = retval | bit(12);
	  retval = retval | bit(index->use[i]);
	}
    }
  return(retval);
}

int traceword(word)
     char *word;
{
  ndex *index;
  int i,j;
  synset *nusynset;
  int total=0;
  
  index = lookup_binx(word,NOUNSS);
  if(index->true)
    {
      for(i=0;i<index->num;i++)
	{
	  nusynset=nuscan(NOUNSS,index->off[i],"");
	  total += tracesense(nusynset,HASPARTPTR,NOUNSS,1,0);
	}
    }
  return(total);
}

synset *nuscan(dbase,boffset,word)
     int  dbase;
     long boffset;
     char *word;
{
  char *foo;
  char *getenv();
  char searchdir[512];
  char dataname[512];
  FILE *fp,*fopen();
  char line[4096];
  char tbuf[256];
  char *headptr;
  char *ptrtok;
  char *deluded;
  char *tmpptr;
  char tnum[256];
  char too[3],tfrm[3];
  int i,j;
  
  synset *retval;
  retval = (synset *) farmalloc(sizeof(synset));

  retval->true=0;
  retval->hereiam=0;
  retval->sstype=0;
  retval->fnum=0;
  retval->pos='\0';
  retval->wcount=0;
  retval->words='\0';
  retval->whichword=0;
  retval->ptrcount=0;
  retval->ptrtyp='\0';
  retval->ptroff='\0';
  retval->ptoo='\0';
  retval->pfrm='\0';
  retval->fcount=0;
  retval->frmid='\0';
  retval->frmto='\0';
  retval->defn='\0';
  
  strcpy(searchdir,((foo=getenv("WNSEARCHDIR")) ? foo
		    : "."));
  sprintf(dataname,"%s\\%s.ibm",searchdir,partnames[dbase]);
  if((fp=fopen(dataname,"r")) == NULL) {
    fprintf(stderr, "Error: can't open datafile(%s)\n",dataname);
    exit(666);
  }
  
  fseek(fp,boffset,0);
  fgets(line, 4096, fp);
  fclose(fp);
  
  ptrtok=line;
  headptr=line;

  retval->true=1;
  
  if((dbase==ADJSS) && strchr(headptr,'!'))
    retval->sstype=1;
  else
    retval->sstype=0; 
  
  /* looking at offset */
  ptrtok=strtok(line," \n");
  sprintf(tnum,"%s",ptrtok);
  retval->hereiam=strtol(tnum,NULL,10);
  
  /* looking at FNUM */
  ptrtok=strtok(NULL," \n");
  retval->fnum=atoi(ptrtok);
  
  /* looking at POS */
  ptrtok=strtok(NULL," \n");
  retval->pos = (char *) farmalloc(strlen(ptrtok) + 1);

  sprintf(retval->pos,"%s",ptrtok);
  
  /* looking at numwords */
  ptrtok=strtok(NULL," \n");
  sprintf(tnum,"%s",ptrtok);
  retval->wcount=strtol(tnum,NULL,16);
  
  retval->words=(char **) farmalloc(retval->wcount  * sizeof(char *));

  sprintf(tbuf,"");
  for(i=0;i<retval->wcount; i++)
    {
      ptrtok=strtok(NULL," \n");
      sprintf(tbuf,"%s",ptrtok);
      if(!strcmp(word,deadjify(strtolower(ptrtok))))
	retval->whichword = i+1;
      retval->words[i]= (char *) farmalloc(strlen(tbuf) + 1);

      sprintf(retval->words[i],"%s",deadjify(tbuf));
    }
  
  /* get the pointer count */
  ptrtok=strtok(NULL," \n");
  retval->ptrcount=atoi(ptrtok);
  
  /* alloc storage for the pointers */
  retval->ptrtyp=(int *) farmalloc(retval->ptrcount *sizeof(int));

  retval->ptroff=(long *) farmalloc(retval->ptrcount * sizeof(long));

  retval->ptoo=(int *) farmalloc(retval->ptrcount * sizeof(int));

  retval->pfrm=(int *) farmalloc(retval->ptrcount * sizeof(int));

  for(i=0;i<retval->ptrcount;i++)
    {
      /* get the pointer type */
      ptrtok=strtok(NULL," \n");
      for(j=0;j<MAXPTR;j++)
	{
	  if(!strcmp(ptrtok,ptrtyp[j]))
	    retval->ptrtyp[i]=j;
	}
      
      ptrtok=strtok(NULL," \n");
      sprintf(tnum,"%s",ptrtok);
      retval->ptroff[i]=strtol(tnum,NULL,10);
      
      /* get the lexp to/from restrictions */
      ptrtok=strtok(NULL," \n");
      
      tmpptr=ptrtok;
      strncpy(tfrm,tmpptr,2);
      tfrm[2]='\0';
      retval->pfrm[i]=atoi(tfrm);
      
      tmpptr += 2;
      strncpy(too,tmpptr,2);
      too[2]='\0';
      retval->ptoo[i]=atoi(too);
    }
  
  /* retireve optional information from verb synset */
  if(dbase == VERBSS)
    {
      ptrtok=strtok(NULL," \n");
      retval->fcount=atoi(ptrtok);
      
      /* allocate frame storage */
      
      retval->frmid=(int *) farmalloc(retval->fcount * sizeof(int));

      retval->frmto=(int *) farmalloc(retval->fcount * sizeof(int));

      for(i=0;i<retval->fcount;i++)
	{
	  /* skip the frame pointer (+) */
	  ptrtok=strtok(NULL," \n");
	  
	  ptrtok=strtok(NULL," \n");
	  retval->frmid[i]=atoi(ptrtok);
	  
	  ptrtok=strtok(NULL," \n");
	  retval->frmto[i]=atoi(ptrtok);
	}
    }
  
  /* get the optional definition */
  
  ptrtok=strtok(NULL," \n");
  if(ptrtok)
    {
      ptrtok=strtok(NULL," \n");
      sprintf(tbuf,"");
      while(ptrtok != NULL)
	{
	  strcat(tbuf,ptrtok);
	  ptrtok=strtok(NULL," \n");
	  if(ptrtok)
	    strcat(tbuf," ");
	}
      retval->defn=(char *) farmalloc(strlen(tbuf) + 10);

      sprintf(retval->defn,"(%s)",tbuf);
    }
  
  return(retval);
}

void traceptrs(oldsynset,ptrtyp,dbase,depth)
     synsetptr oldsynset;
     int ptrtyp;
     int dbase;
     int depth;
{
  int i,j;
  char tbuf[1024];
  synset *retval;

    if( ((ptrtyp == HYPOPTR) && (depth == 1)) && oldsynset->fnum == 0)
   {
    depth = -1;

    sound(550);

    fprintf(stdout,"\n\nWARNING!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
    fprintf(stdout,"\nThe following part of the search you specified would\n");
    fprintf(stdout,"have returned an unmanageable amount of data.  Please \n");
    fprintf(stdout,"respecify your search with one of the following\n");
    fprintf(stdout,"\nWARNING!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n\n");

    delay(1000);
    nosound();
    delay(1000);	
   
}


  for(i=0;i<oldsynset->ptrcount;i++)
    {
      if((oldsynset->ptrtyp[i] == ptrtyp) &&  ((oldsynset->ptoo[i] == 0) || (oldsynset->ptoo[i] == oldsynset->whichword)))
	{
	  if(repcount == 0)
	    {
	      sprintf(tbuf,"\nSense %d",sense+1);
	      sprintbuffer(tbuf);
	      
	      sprintsynset("\n",oldsynset,"\n",DEFON);
	      repcount++;
	    }
	  
	  retval=nuscan(dbase,oldsynset->ptroff[i],"");
	  for(j=0;j<depth;j++)
	   {
	     sprintbuffer("    ");
	   }
	  sprintbuffer("   ");
	  if(!depth)
	    {
	      sprintbuffer("       ");
	    }
	  
	  if(ptrtyp == SEEALSOPTR)
	    sprintsynset("See Also => ",retval,"\n",DEFON);
	  else
	    sprintsynset("=> ",retval,"\n",DEFON);
	  
	  if(depth)
	    {
	      if(depth>15)
		{
		  if(depth == 16)
		    fprintf(stderr,"Error Cycle detected\n");
		  fprintf(stderr,"   %s\n",retval->words[0]);
		  if(depth==20)
		    depth=-1;
		}
	      traceptrs(retval,ptrtyp,dbase,(depth+1));
            }	
	}
    }
}

void traceotherptrs(oldsynset,ptrtyp,dbase,depth)
     synsetptr oldsynset;
     int ptrtyp;
     int dbase;
     int depth;
{
  int i,j;
  char tbuf[1024];
  synset *retval;
  
  for(i=0;i<oldsynset->ptrcount;i++)
    {
      if((oldsynset->ptrtyp[i] == HYPERPTR) &&  ((oldsynset->ptoo[i] == 0) || (oldsynset->ptoo[i] == oldsynset->whichword)))
	{
	  if(repcount == 0)
	    {
	      sprintf(tbuf,"\nSense %d",sense+1);
	      sprintbuffer(tbuf);
	      
	      sprintsynset("\n-> ",oldsynset,"\n",DEFON);
	      repcount++;
	    }
	  
	  retval=nuscan(dbase,oldsynset->ptroff[i],"");
	  
	  
	  for(j=0;j<depth;j++)
	    sprintbuffer("    ");
	  if(!depth)
	    sprintbuffer("\n    ");
	  
	  sprintsynset("-> ",retval,"\n",DEFON);
	  
	  traceptrs(retval,ptrtyp,NOUNSS,depth);
	  
	  if(depth)
	    {
	      if(depth>15)
		{
		  if(depth == 16)
		    fprintf(stderr,"Error Cycle detected\n");
		  fprintf(stderr,"   %s\n",retval->words[0]);
		  if(depth==20)
		    depth=-1;
		}
	      traceotherptrs(retval,ptrtyp,dbase,(depth+1));
            }	
	}
    }
}

int tracesense(oldsynset,ptrtyp,dbase,depth,numparts)
     synsetptr oldsynset;
     int ptrtyp;
     int dbase;
     int depth;
     int numparts;
{
  int i,j;
  static int count;
  
  synset *retval;

  count = numparts;
  
  for(i=0;i<oldsynset->ptrcount;i++)
    {
      if(oldsynset->ptrtyp[i] == HASPARTPTR)
	{
	  count++;
	}
    }
  
  for(i=0;i<oldsynset->ptrcount;i++)
    {
      if(oldsynset->ptrtyp[i] == HYPERPTR)
	{
	  retval=nuscan(dbase,oldsynset->ptroff[i],"");
	  for(j=0;j<retval->ptrcount;j++)
	    {
	      if(retval->ptrtyp[j] == HASPARTPTR)
		count++;
	    }
	  
	  if(depth)
	    {
	      if(depth>15)
		{
		  fprintf(stderr,"Error Cycle detected\n");
		  depth=-1;
		}
	      tracesense(retval,ptrtyp,dbase,depth+1,count);
            }	
	}
    }
  return(count);
}


void tracecoord(oldsynset,depth)
     synsetptr oldsynset;
     int depth;
{
  traceotherptrs(oldsynset,HYPOPTR,NOUNSS,depth);
}

void adjanttrace(oldsynset,ptrtyp,dbase)
     synsetptr oldsynset;
     int ptrtyp;
     int dbase;
{
  int i=0,j=0;
  int indirect;
  char tbuf[1024];

  synset *retval,*simptr,*antptr,*tmpptr;
  
  /*  indirect=oldsynset->sstype;  */
  indirect=1;
  
  if(oldsynset->sstype ==0)
    {
      sprintf(tbuf,"\nSense %d",sense+1);
      sprintbuffer(tbuf);
      
      sprintsynset("\n",oldsynset,"\n",DEFON);
      oldsynset=nuscan(dbase,oldsynset->ptroff[0],"");
      sprintsynset("\t<via:",oldsynset,">",DEFON);
      indirect=0;
    }
  else
    {
      /* You have to look at the big/large large/big synsets to understand this */
      while(oldsynset->ptrtyp[j] != ANTPTR)
	{
	  j++;
	}
      if((oldsynset->whichword != oldsynset->ptoo[j]) && (oldsynset->ptoo[j] != 0))
	{
	  sprintf(tbuf,"\nSense %d",sense+1);
	  sprintbuffer(tbuf);
	  sprintsynset("\n",oldsynset,"\n",DEFON);
	  sprintsynset("\t<via:",oldsynset,">",DEFON);
	  indirect=0;
	}
      else
	{
	  sprintf(tbuf,"\nSense %d",sense+1);
	  sprintbuffer(tbuf);
	  sprintsynset("\n",oldsynset,"\n",DEFON);
	}
    }
  
  for(i=0;i<oldsynset->ptrcount;i++)
    {
      if(oldsynset->ptrtyp[i] == ptrtyp)
	{
	  antptr=nuscan(dbase,oldsynset->ptroff[i],"");
	  sprintsynset(" => ",antptr," ",DEFON);
	  if(indirect)
	    {
	      sprintbuffer("\n");
	      for(j=0;j<antptr->ptrcount;j++)
		{
		  if(antptr->ptrtyp[j] == SIMPTR)
		    {
		      simptr=nuscan(dbase,antptr->ptroff[j],"");
		      sprintsynset("\t(via:",antptr,") => ",DEFOFF);
		      sprintsynset(" ",simptr,"\n",DEFON);
		    }
		}
	    }
	}
    }
  sprintbuffer("\n");
}

void partsall(oldsynset)
     synset *oldsynset;
{
  
  synset *newsynset;
  
  if(tracesense(oldsynset,HASPARTPTR,NOUNSS,1,0))
    {
      traceptrs(oldsynset,HASPARTPTR,NOUNSS,1);
      traceotherptrs(oldsynset,HASPARTPTR,NOUNSS,1);
    }
}


void printframe(oldsynset)
     synsetptr oldsynset;
{
  int i,j=0;
  char tbuf[1024];

  sprintf(tbuf,"\nSense %d",sense+1);
  sprintbuffer(tbuf);

  sprintsynset("\n",oldsynset,"\n",DEFON);
  
  for(i=0;i<oldsynset->fcount;i++)
    {
      if((oldsynset->frmto[i] == oldsynset->whichword)  || (oldsynset->frmto[i] == 0))
	{
	  sprintbuffer("\t=> ");
	  sprintbuffer(frametext[oldsynset->frmid[i]]);
	  sprintbuffer("\n");
	}
    }
  
}

void freq_word(word,dbase)
     char *word;
     int dbase;
{
  ndexptr index;
  int familiar=0;
  char tbuf[256];
  
  index=lookup_binx(word,dbase);
  if (index->col==0) familiar = 0;
  if (index->col==1) familiar = 1;
  if (index->col==2) familiar = 2;
  if (index->col>=3 && index->col<=4) familiar = 3;
  if (index->col>=5 && index->col<=8) familiar = 4;
  if (index->col>=9 && index->col<=16) familiar = 5;
  if (index->col>=17 && index->col<=32) familiar = 6;
  if (index->col > 32 ) familiar = 7;
  if(index->true)
    {
      sprintf(tbuf,"\nThe %s familiarity of %s is %s\n",partnames[dbase],word,freqcats[familiar]);
      sprintbuffer(tbuf);
    }
  
}

void sprintsynset(string1,synptr,string2,definition)
     char *string1;
     synset *synptr;
     char *string2;
     int definition;
{
  int i=0;
  int delta=0;

  char *foo;
  char *getenv();

  char tbuf[1024];
  char *retval;

  sprintf(tbuf,"");

  if(getenv("WNDEBUG") != NULL)
    {
      if(!strcmp(synptr->pos,"n"))
	sprintf(tbuf,"<%s>",nfnames[synptr->fnum]);
      if(!strcmp(synptr->pos,"a"))
	sprintf(tbuf,"<%s>",afnames[synptr->fnum]);
      if(!strcmp(synptr->pos,"v"))
	sprintf(tbuf,"<%s>",vfnames[synptr->fnum]);
    }

  strcat(tbuf,string1);
  for(i=0;i<(synptr->wcount -1);i++)
    {
      strcat(tbuf,synptr->words[i]);
      strcat(tbuf,", ");
    }
  if(synptr->wcount)
    strcat(tbuf,synptr->words[i]);

  if((dflag && synptr->defn) && definition)
    {
      strcat(tbuf," --  ");
      strcat(tbuf,synptr->defn);
    }
  strcat(tbuf,string2);
  /*
  delta = (MAXBUFF - strlen(printbuffer)) - strlen(tbuf);
  if(delta <= 0)
    {
      delta = delta * (-1);
      MAXBUFF += (delta + 4096);
      printbuffer = realloc(printbuffer,MAXBUFF);
    }
  strcat(printbuffer,tbuf);
  */
  fprintf(stdout,"%s",tbuf);
}

void sprintbuffer(string)
     char *string;
{
  int delta=0;
 /*

  delta = (MAXBUFF - strlen(printbuffer)) - strlen(string);
  if(delta <= 0)
    {
      delta = delta * (-1);
      MAXBUFF += (delta + 4096);
      printbuffer = realloc(printbuffer,MAXBUFF);
    }
  strcat(printbuffer,string);
  */
  fprintf(stdout,"%s",string);
}

void dumpit()
{
  int i;
  fprintf(stdout,"%s\n",printbuffer);
}

void printindex(dex)
     ndex *dex;
{
  int i;

  fprintf(stdout,"\nWord    = %s\n",dex->wd);
  fprintf(stdout,"Pos     = %s\n",dex->pos);
  fprintf(stdout,"Collins = %d\n",dex->col);
  fprintf(stdout,"Ptrcnt  = %d\n",dex->num);
  for(i=0;i<dex->num;i++)
    fprintf(stdout,"Offset[%d] = %d\n",i,dex->off[i]);
  fprintf(stdout,"PtrTypCnt  = %d\n",dex->cnt);
  for(i=0;i< dex->cnt;i++)
    fprintf(stdout,"Ptr[%d] = %s\n",i,ptrtyp[dex->use[i]]);
}

char *findtheinfo(word,dbase,ptrtyp)
     char *word;
     int dbase;
     int ptrtyp;
{
  ndexptr    test;
  synsetptr upsyn;
  
  char tbuf[256];
  int depth=0;
  int adjflag=0;
  int j;
  
  if(ptrtyp < 0)
    {
      ptrtyp *= -1;
      depth=1;
    }
  
  /* initialize printbuffer */
  printbuffer = (char *) farmalloc(MAXBUFF * sizeof(char));

  sprintf(printbuffer,"");

  if(ptrtyp == FREQ)
    {
      freq_word(word,dbase);
    }
  else
    if(ptrtyp == ISDEF)
      {
	test=lookup_binx(word,dbase);
	if(test->true)
	  {
	    sprintf(tbuf,"\n%s <%s>\n",test->wd,partnames[dbase]);
	    sprintbuffer(tbuf);
	    for(sense=0;sense<test->cnt;sense++)
	      {
		if(dbase == ADJSS)
		  {
		    if(test->use[sense] == ANTPTR)
		      adjflag++;
		  }
		sprintf(tbuf,"\t%s\n",isdef[test->use[sense]]);
		sprintbuffer(tbuf);
	      }

	    /* take care of indircet adjective antonyms */
	    if((dbase == ADJSS) && !(adjflag))
	      {
		sprintf(tbuf,"\t%s\n",isdef[14]);
		sprintbuffer(tbuf);
	      }

	    sprintf(tbuf,"\t%s\n\t%s\n",isdef[26],isdef[27]);
	    sprintbuffer(tbuf);
	    if(dbase == 1)
	      {
		if(traceword(word))
		  {
		    sprintf(tbuf,"\t%s\n",isdef[32]);
		    sprintbuffer(tbuf);
		  }
		/* put in coordinate test here */
		for(j=0;j<test->cnt;j++)
		  {
		    if(test->use[j] == HYPERPTR)
		      {
			sprintf(tbuf,"\t%s\n",isdef[31]);
			sprintbuffer(tbuf);
			j = test->cnt;
		      }
		  }
	      }
	  }
	else
	  {
	    sprintf(tbuf,"\nSorry, no information available for %s <%s>\n",word,partnames[dbase]);
	    sprintbuffer(tbuf);
	  }
      }
    else
      {
	test=lookup_binx(word,dbase);
	
	for(sense=0;sense<test->num;sense++)
	  {
	    repcount=0;
	    upsyn=nuscan(dbase,test->off[sense],test->wd);
	    
	    switch(ptrtyp)
	      {
	      case ANTPTR:    if(dbase == ADJSS)
		adjanttrace(upsyn,ptrtyp,dbase);
	      else
		traceptrs(upsyn,ANTPTR,dbase,depth);
		break;
		
	      case COORDS:    tracecoord(upsyn,depth);
		break;

	      case FRAMES:    printframe(upsyn);
		break;
		
	      case MERONYM:   traceptrs(upsyn,MERONYM,dbase,depth);
		traceptrs(upsyn,HASMEMBERPTR,dbase,depth);
		traceptrs(upsyn,HASSTUFFPTR,dbase,depth);
		traceptrs(upsyn,HASPARTPTR,dbase,depth);
		break;
		
	      case HOLONYM:   traceptrs(upsyn,HOLONYM,dbase,depth);
		traceptrs(upsyn,ISMEMBERPTR,dbase,depth);
		traceptrs(upsyn,ISSTUFFPTR,dbase,depth);
		traceptrs(upsyn,ISPARTPTR,dbase,depth);
		break;
		
	      case HMERONYM:  partsall(upsyn);
		break;
		
	      default:        
		if((dbase == NOUNSS && upsyn->fnum == 0) && (ptrtyp == HYPERPTR && depth == 0))
		{
		  sprintf(tbuf,"\nSense %d",sense+1);
		  sprintbuffer(tbuf);
		  sprintsynset("\n",upsyn,"\n",DEFON);
		  repcount++;
		}
		if((dbase == VERBSS && (ptrtyp == HYPERPTR && depth == 0)))
		  {
		   sprintf(tbuf,"\nSense %d",sense+1);
		   sprintbuffer(tbuf);
		   sprintsynset("\n",upsyn,"\n",DEFON);
		   repcount++;
		  }
		traceptrs(upsyn,ptrtyp,dbase,depth);
		if(dbase == ADJSS)
		  traceptrs(upsyn,SEEALSOPTR,dbase,depth);
		break;
	      }
	  }      
      }
  return(strsubst(printbuffer,'_',' '));
}
